var $ = require('jquery');
module.exports = {
    get: function (url){
        var defer = $.Deferred();
        $.ajax({
  			url: url,
  			method: 'GET',
            success: defer.resolve,
            error: defer.reject
  		});

        return defer.done().promise();
  	},
    post: function (url, data, callback){
        var defer = $.Deferred();
        var _ajax = {
  			url: url,
  			method: 'POST',
            processData: false,
            contentType: "application/json; charset=UTF-8",
            dataType: "json",
  			data: JSON.stringify(data),
            success: defer.resolve,
            error: defer.reject
  		};

        $.ajax(_ajax);
        return defer.done(callback).promise();
  	},
    delete: function (url, data, callback){
        var defer = $.Deferred();
        $.ajax({
  			url: url,
  			method: 'DELETE',
            contentType: "application/json; charset=UTF-8",
            dataType: "json",
  			data: JSON.stringify(data),
            success: defer.resolve,
            error: defer.reject
  		});

        return defer.done(callback).promise();
  	},
    put: function (url, data, callback){
        var defer = $.Deferred();
        $.ajax({
  			url: url,
  			method: 'PUT',
            contentType: "application/json; charset=UTF-8",
            dataType: "json",
  			data: JSON.stringify(data),
            success: defer.resolve,
            error: defer.reject
  		});

        return defer.done(callback).promise();
  	},
    jsonp: function (url, data){
        var defer = $.Deferred();
        $.ajax({
            url: url,
            data: data,
            dataType: "jsonp",
            success: defer.resolve,
            error: defer.reject
        });

        return defer.done().promise();
    }
}
