module.exports = {
    format: function (str, value){
        var _value = null;
        for(var key in value){
            _value = value[key];
            if(typeof _value == 'object'){
                _value = JSON.stringify(_value);
            }
            str = str.replace(new RegExp('\\{'+key+'\\}', 'gi'), _value);
        }

        return str;
    },
    uuid: function (){
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        }).toUpperCase();
    },
    extend: function (target) {
        for (var i = 1, length = arguments.length; i < length; i++) {
            var arg = arguments[i];
            for (var key in arg) {
                if (arg.hasOwnProperty(key)) {
                    target[key] = arg[key];
                }
            }
        }

        return target;
    }
}
